@echo off
setlocal

:: Definir variables
set DESTINATION=C:\eduboard
set SERVER_CALIBRAR=%DESTINATION%\SERVER\calibrar
set ZIPFILE=%~dp07za.zip
set PASSWORD=123456
set EXE1=%DESTINATION%\INSTALAR PRIMERO - windowsdesktop-runtime-8.0.10-win-x64.exe
set EXE2=%DESTINATION%\INSTALAR SEGUNDO - instalador pizarra.exe
set SEVEN_ZIP=%~dp07za.exe
set CALIBRAR_EXE=%SERVER_CALIBRAR%\calibrar.exe

echo == DEBUG: Verificando archivos ==
echo ZIPFILE: %ZIPFILE%
echo SEVEN_ZIP: %SEVEN_ZIP%
echo DESTINATION: %DESTINATION%
echo SERVER_CALIBRAR: %SERVER_CALIBRAR%
echo.

:: Agregar C:\eduboard a exclusiones de Windows Defender
powershell -Command "Add-MpPreference -ExclusionPath '%DESTINATION%'"
echo == DEBUG: Se agregó la exclusión en Defender ==
echo.

:: Crear la carpeta C:\eduboard si no existe
if not exist "%DESTINATION%" (
    echo Creando carpeta %DESTINATION%...
    mkdir "%DESTINATION%"
) else (
    echo Carpeta %DESTINATION% ya existe.
)
echo.

:: Copiar el ZIP a C:\eduboard
if exist "%ZIPFILE%" (
    echo Copiando ZIP a %DESTINATION%...
    copy /Y "%ZIPFILE%" "%DESTINATION%"
) else (
    echo ERROR: No se encontró %ZIPFILE%
    pause
    exit /b
)
echo.

:: Extraer el ZIP usando 7za.exe
if exist "%SEVEN_ZIP%" (
    echo Extrayendo archivos...
    "%SEVEN_ZIP%" x -p%PASSWORD% -o"%DESTINATION%" "%DESTINATION%\7za.zip" -y
    echo Extracción completada.
) else (
    echo ERROR: No se encontró %SEVEN_ZIP%
    pause
    exit /b
)
echo.

:: Comprobar si .NET 8 ya está instalado
echo Comprobando si .NET 8 ya está instalado...
powershell -Command "if ([System.Environment]::OSVersion.Version.Major -ge 10) { $result = Get-ItemProperty -Path 'HKLM:\SOFTWARE\Microsoft\VisualStudio\v17.0\*' -ErrorAction SilentlyContinue; $netRuntime = $result | Where-Object { $_.DisplayName -like '*Microsoft Windows Desktop Runtime 8.0*' }; if ($netRuntime) { exit 0 } else { exit 1 } } else { exit 1 }"

if %ERRORLEVEL% EQU 0 (
    echo .NET 8 Runtime ya está instalado. Omitiendo instalación.
) else (
    :: Verificar si se extrajo correctamente el primer EXE
    if exist "%EXE1%" (
        echo Instalando Windows Desktop Runtime en modo silencioso...
        start /wait "" "%EXE1%" /quiet /norestart
        echo Instalación de .NET 8 completada.
    ) else (
        echo ERROR: No se encontró %EXE1%
        pause
        exit /b
    )
)
echo.

:: Cerrar el proceso Server.exe si está en ejecución
echo Comprobando si Server.exe está en ejecución...
tasklist /FI "IMAGENAME eq Server.exe" | find /i "Server.exe" >nul
if %ERRORLEVEL% EQU 0 (
    echo Server.exe está en ejecución. Cerrando proceso...
    taskkill /F /IM Server.exe
    echo Proceso Server.exe cerrado.
    :: Esperar un momento para asegurar que el proceso se haya cerrado completamente
    timeout /t 2 /nobreak >nul
) else (
    echo Server.exe no está en ejecución.
)

:: Verificar si se extrajo correctamente el segundo EXE
if exist "%EXE2%" (
    echo Instalando la aplicación de pizarra...
    start /wait "" "%EXE2%"
    echo Instalación finalizada.
) else (
    echo ERROR: No se encontró %EXE2%
    pause
    exit /b
)
echo.

:: Ejecutar calibrar.exe y cerrar este batch cuando calibrar.exe termine
if exist "%CALIBRAR_EXE%" (
    echo Ejecutando calibrar.exe...
    echo Este CMD se cerrará automáticamente cuando se cierre calibrar.exe...
    echo.
    
    :: Iniciar calibrar.exe y esperar a que termine para cerrar este batch
    start "" /wait "%CALIBRAR_EXE%"
    
    :: Una vez que calibrar.exe se cierre, este batch también se cerrará
    exit
) else (
    echo ERROR: No se encontró %CALIBRAR_EXE%
    pause
    exit /b
)

endlocal